/* 
 * CSE142, 98 Autumn
 * Homework 4
 * Rain Gods and Goddesses */


/* There's a landscape in the background...

*/

#include "gp142.h"
#include <stdio.h>

/* <time.h> is used to call a function that generate random numbers*/
#include <time.h>

/* This defines the status of calls to certain functions           */
#define TRUE    		1
#define FALSE   		0

/* Configuration of the buttons on the menu bar                    */
/* number of pixels of button height and width                     */
#define BUTTON_HEIGHT  	35
#define BUTTON_WIDTH 	100
#define NUM_BUTTONS 	11

/*color of letter on buttons                                       */
#define SELECTED_COLOR   PINK 
#define UNSELECTED_COLOR LT_GRAY

/*This is the total number of drops possible at one time.          */
#define MAX_PRECIP_EVENTS	500
	
/* y-ccordinate of the top of the "dirt" in the landscape          */
#define TOP_OF_DIRT (- 2 * (GP142_YMAX / 5))

/* zero means to fill the shape being drawn                        */
#define FILL 0

/* Types of precipitations supported                               */
#define NONE 0
#define RAIN 1
#define SNOW 2
#define HAIL 3
#define HEART 4

#define MAX_PRECIP_TYPES 4


/*Possible places for mouse clicks*/
#define BUTTON 1

/*This means you clicked in the dirt area                          */
#define DIRT 2

/* Types of precipitation removal                                  */
#define LIGHTEN_UP 9
#define CEASE 10


/*******************  FUNCTION PROTOTYPES **************************/

/*Redraw all the buttons.
The parameters tell which button should be highlighted             */
void DrawButtons(int current_precip, int current_color);

/*Clear all percipitation, so the landscape is just as originally  */
void ClearAllPrecipitation(int *precip_type);

/*Clear some precipitation                                         */
void ClearSomePrecipitation(int *precip_event);

/* The positions for every drop of precipitation                   */
void DrawPrecipColumn(int number, int current_x, int current_y, 
						  int current_precip_color, 
						  int current_precip_type,
						  int x[], int y[],
						  int color[], int type[]);

/* Render (draw) all the precipitation                             */
void DrawAllPrecipitation(int x[], int y[], 
						  int color[], int type[],
						  int count);

/* Draw the setting                                                */
void DrawLandscape();
void DrawChristmasTree();
void DrawClouds();
void DrawStanley();
void DrawKenny(Kenny_X, Kenny_Y, color_1, color_2,
			   color_3, color_4, color_5, color_6, color_7);

/* This function is called to kill Kenny                           */
void DrawStone(int stone_x, int stone_y, int stone_status);

/* Draw Christmas Tree Ornaments                                   */
void DrawDiamonds (color, diamond_x, diamond_y);
void DrawHearts (color, heart_x, heart_y);
void DrawSpades (color, spade_x, spade_y);
void DrawClubs( color, club_x, club_y);
					  
/* Draw a type of precipitation                                    */
void DrawRainDrop (int x, int y, int color);
void DrawSnowDrop (int x, int y, int color);
void DrawHailDrop (int x, int y, int color);
void DrawHeartDrop (int x, int y, int color);

/*Return an integer which tells what KIND of click there was       */
int ClassifyMouseClick(int mouse_x, int mouse_y);

/*Given that a button was click, call an appropriate function to handle it*/
void handle_button(int x, int y, int *current_precip, int *current_color,
		           int *clear_weather, int *killing);

/* This is the function which displays the opening screen          */
void opening();

/* This function is only called when user input something wrong    */
void BadNewsMessage();

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
initialize them,
and to contain the "event loop," which constantly looks to see if an event has
happened, and then processes the event by calling an appropriate function.   */
int main(void)
{
  int quit = FALSE;
  int mouse_x, mouse_y;
  char key_hit;

/* initialize the position of the moon                             */
  int moon_x =GP142_XMAX - 50, moon_y = GP142_YMAX - 35;
  int shadow_x =GP142_XMAX - 40, shadow_y = GP142_YMAX - 35;

/* 
 * The next itens tell what weather is happening, 
 its "leading edge" or bottom (how far down it is), and its color.
 As time passes, the bottom gets lower and lower.                  */

/* These are the variables which hold information such as the position of 
   a precipitation, its color and type                             */
  int precip_type[MAX_PRECIP_EVENTS];
  int precip_color[MAX_PRECIP_EVENTS];
  int bottom_x[MAX_PRECIP_EVENTS];
  int bottom_y[MAX_PRECIP_EVENTS];

/* Initializing the number of precipitation                        */
  int num_precip = 0;

/* The counter which is used in various loops                      */
  int i;

/* A random number                                                 */
  int random;
    
/* what to draw next                                               */
  int current_precip = NONE, current_color = NONE; 
  
/*This flag will be true if all weather should be cleared          */
  int clear_flag = FALSE;

/*Killing will be true if user decide to kill Kenny                */
  int killing = FALSE;

/*Initialization for the position of the stone and Kenny           */
  int init_stone_x = -100;
  int init_stone_y = GP142_YMAX - 70;
  int init_Kenny_X = 0;
  int init_Kenny_Y = 0;

/* determining the coordinates where the mouse is clicked          */
  int mouse_click;

/*the most recent GP142 event*/
  int event;
  
/*needed only when initializing a random number generator          */
  time_t t;
  
/* used random numbers to seed the random number generator         */   
  srand (time(&t));	                  
		  
/* Open and init the GP142 Graphics Window                         */
  GP142_open();
  
/* This function can also be changed to LOG_ON                     */
  GP142_logging(LOG_OFF); 
 
/* This will clear the window & paint it white.                    */
  GP142_clear();

/* This will display the opening screen                            */
  opening();
  
/* Start animation so precips will grow                            */
  GP142_animate(ANI_RUN); 

/* Draw the settings                                               */
  DrawLandscape();
  DrawStanley();
  DrawKenny(init_Kenny_X, init_Kenny_Y, BROWN,ORANGE, BROWN, BROWN,
	        BLACK, WHITE, CHALK);

/* Show the buttons...                                             */ 
  DrawButtons(current_precip, current_color);
  
/* Clear up all precipitation                                      */
  ClearAllPrecipitation (&num_precip);
  
  
  /*
   * The main event loop:
   * --- ---- ----- -----
   * wait for the next user action, such as a mouse click or keyboard
   * keypress, or a periodic update event (allowing us to display the
   * next frame of an animation -- not used int this program)
   * and call the appropriate function to
   * handle it.  Repeat this until the user signals "quit".
   */

/*this is the famous "event loop"                                           */
  while (!quit) {  

	/*find out what has happened */
	event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);

	switch (event) {
    /* set flag to terminate loop */  
    case GP142_QUIT:
      quit = TRUE;           
      break;
    
	/* The characters on keyboard are only used in the opening screen to
	   into the main part of the program.                                   */
    case GP142_KBD:
	  break;

    case GP142_MOUSE:
	  /* a mouse click has occurred. */
      /* check for button versus dirt */
      /* handle appropriate button click, if any */
      mouse_click = ClassifyMouseClick(mouse_x, mouse_y);

	if (mouse_click == BUTTON) {
  	  /* a button has been clicked.  Call a function to handle it   */
		handle_button(mouse_x, mouse_y, 
		      &current_precip, &current_color, &clear_flag,
			  &killing);
      /* If user decides to clear up precipitation. Call appropriate
	     functions to do so                                         */
		if (clear_flag)
			switch(clear_flag) {

	        case LIGHTEN_UP:
		     ClearSomePrecipitation(&num_precip);
			 break;

	        case CEASE:
			 ClearAllPrecipitation(&num_precip);
			 break;

	        default:
	       	 break;		
		}        
		
	} else if ((mouse_click != DIRT) && 
		 (current_precip != NONE) && (current_color != NONE) &&
		 num_precip < MAX_PRECIP_EVENTS){
      /* Locate the places where user wants to create precipitations*/
		DrawPrecipColumn(num_precip, mouse_x, mouse_y, 
			             current_color, current_precip,
						 bottom_x, bottom_y, precip_color,
						 precip_type);
		
		num_precip = num_precip + 1;
	} 
      
      break;
	 
    case GP142_PERIODIC:

		/* change the sun's position a little bit*/
		moon_x --;
		if (moon_x < -GP142_XMAX -30) {
			moon_x = - moon_x;	    
		}

		shadow_x --;
		if (shadow_x < -GP142_XMAX - 30){
			shadow_x = - shadow_x;			
		}

		/* Make the precipitation a little lower at different rates */
		for (i=0; i < num_precip; i++){
			if (bottom_y[i] > -GP142_YMAX){
				bottom_y[i] = bottom_y[i] - rand()%7;

				/*Make the precipitation reappears after it hits the
				  ground                                            */
					if(bottom_y[i] < TOP_OF_DIRT - 15){
					   bottom_y[i] = GP142_YMAX;

					   /* Vary the amount at which new precipitations
					      are created                               */
                       random = rand()%3;
					   if(random == 1 && num_precip < MAX_PRECIP_EVENTS){
			              bottom_x[num_precip] = bottom_x[i];
			              bottom_y[num_precip] = bottom_y[i] + 20;
			              precip_type[num_precip] = precip_type[i];
			              precip_color[num_precip] = precip_color[i];
			              num_precip = num_precip + 1;
					   }

					}
				/* Make the precipitation wiggle left or right      */
				bottom_x[i] = bottom_x[i] + rand()%2;
				bottom_x[i] = bottom_x[i] - rand()%2;
			}			
		}

		/* Make the stone drops and hits Kenny if user decides so   */
		if (killing ==TRUE){
		   if(init_stone_y > -GP142_YMAX){
		      init_stone_y = init_stone_y - 10;
		   }
		   
		   if (init_stone_y <= -192){
			   init_stone_y = -192;
			   init_Kenny_Y= init_Kenny_Y + 5;
		   }
		   
		}		
		
      break;

    default:
      break;
	
    } /*end switch */ 

    /* Redraw everything */
    DrawLandscape(moon_x, moon_y, shadow_x, shadow_y);
    DrawButtons(current_precip, current_color);
	DrawStanley();
	DrawKenny(init_Kenny_X, init_Kenny_Y, BROWN, ORANGE, BROWN,
		      BROWN, BLACK, WHITE, CHALK);
	/*Only drawn when user decides to do kill Kenny                 */
    DrawStone(init_stone_x, init_stone_y, killing); 
    
/* Draw the Ghost Version of Kenny                                  */
if (init_stone_y == -192){
	DrawKenny(init_Kenny_X, init_Kenny_Y, BLACK, WHITE, 
		      YELLOW, BLACK, BLACK, WHITE, WHITE);
}

/* Change the stone to a tombstone                                  */
if (init_Kenny_Y > GP142_YMAX){
	GP142_lineXY(YELLOW, -75, -190, -75, -124, 5);
	GP142_lineXY(YELLOW, -98, -144, -47, -144, 5);
	GP142_printfXY(BLACK, -87, -140, 15, "RIP");
	GP142_printfXY(BLACK, -90, -165, 10, "Kenny");
	GP142_printfXY(BLACK, -95, -180, 10, "12/24/98");
}

/* Create some thunderous effect as Kenny turns into a ghost        */
if(init_stone_y > -192 && init_stone_y < -182){
    GP142_lineXY(YELLOW, -50, -75, 50, GP142_YMAX, 10);
	GP142_lineXY(YELLOW, -50, -75, 100, 75, 10);
	GP142_lineXY(YELLOW, 100,75, 50, -GP142_YMAX, 10);
}
if (init_Kenny_Y > 0 && init_Kenny_Y < 15){
    GP142_rectangleXY(rand()%2, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
}

/* Draw the precipitations                                          */
DrawAllPrecipitation(bottom_x, bottom_y, precip_color, precip_type,
		                 num_precip);

/* Display some words from Stanley                                  */	
if (init_Kenny_Y >100 && init_Kenny_Y < GP142_YMAX -10){
	GP142_ovalXY(WHITE, -125, -143, -30, -83, FILL);
	GP142_triangleXY(WHITE, -133, -155, -110, -135, -100, -88, FILL);
	GP142_printfXY(BLACK, -107, -105, 12, "Oh My God");
    GP142_printfXY(BLACK, -108, -120, 12,"They Killed");
	GP142_printfXY(BLACK, -102, -135, 12, "Kenny !!!");
}

}  

  /*
   * WRAP-UP
   */

/* clean up and close graphics window   */
  GP142_close();         
   return 0;
}  
/*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/


/*reinitialize so that ALL current precipitation is erased.         */
void ClearAllPrecipitation(int *precip_type)
{  
  *precip_type = 0;  
}

/* This function clears up some precipitation                       */   
void ClearSomePrecipitation(int *precip_count)
{ 
	if(*precip_count > 2){   
    *precip_count = *precip_count - 2;
	}

	else{
		ClearAllPrecipitation(precip_count);
	}
}

/* This function allows user to display more than one precipitation
   simultaneously                                                   */
void DrawPrecipColumn(int number, int current_x, int current_y, 
						  int current_precip_color, 
						  int current_precip_type,
						  int x[], int y[],
						  int color[], int type[])
{
	x[number] = current_x;
	y[number] = current_y;
	color[number] = current_precip_color;
	type[number] = current_precip_type;
}

#define RAINDROP_WIDTH 3

/* Draw the RainDrop whose width is 3                               */
void DrawRainDrop (int x, int y, int color) { 
	
	GP142_circleXY(color, x,y, RAINDROP_WIDTH);
}

#define SNOWDROP_WIDTH 4
#define SNOWDROP_HEIGHT 5

/* Draw the Snow Drop whose width is 4 and height is 5              */
void DrawSnowDrop (int x, int y, int color) {

	GP142_triangleXY(color, x, y, x + SNOWDROP_WIDTH, y,
		             x, y + SNOWDROP_HEIGHT, FILL);
}

#define HAILDROP_WIDTH 5
#define HAILDROP_HEIGHT 4

void DrawHailDrop (int x, int y, int color) {

	GP142_rectangleXY(color, x, y, x + 5, y + 4, FILL);
}

/* Draw the Heart Drop which is also another type of precipitation  */
void DrawHeartDrop( int x, int y, int color) {
	GP142_circleXY(color, x - 3, y + 3, 3);
	GP142_circleXY(color, x + 3, y + 3, 3);
	GP142_triangleXY(color, x - 4, y, x + 4, y, x, y - 4, FILL);
	GP142_pixelXY(color, x, y + 1);
}

/* This function draw the selected type of precipitation            */
void DrawAllPrecipitation(int x[], int y[], 
						  int color[], int type[],
						  int count)
{
	int i;	
	for(i = 0; i < count; i++){

	if (type[i] == RAIN)
			DrawRainDrop(x[i], y[i], color[i]);
		else if (type[i] == SNOW)
			DrawSnowDrop(x[i], y[i],color[i]);
		else if (type[i] == HAIL)
			DrawHailDrop(x[i], y[i], color[i]);
		else if (type[i] == HEART)
			DrawHeartDrop(x[i], y[i], color[i]);		
	}
							
}

/* Recognizing where the mouse is on the graphic window             */
int ClassifyMouseClick(int mouse_x, int mouse_y)
{
  if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH) &&
      (mouse_y < GP142_YMAX) &&
      (mouse_y > (GP142_YMAX - NUM_BUTTONS*BUTTON_HEIGHT)))
    return BUTTON;
  else if (mouse_y <= TOP_OF_DIRT)
    return DIRT;
  else
    return NONE;
}

void DrawLandscape(int moon_x, int moon_y,int shadow_x, int shadow_y)
{  
int text_offset = -GP142_XMAX + 15, font_size = 12;
int i;
int j;

  /* Draw the sky first */
  GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, GP142_YMAX, FILL);
 
  /* Draw the moon */
  GP142_circleXY(YELLOW, moon_x, moon_y , 20);
  GP142_circleXY(BLACK, shadow_x, shadow_y, 20);

  /*Draw the mountains */
  GP142_triangleXY(OLIVE,
		   -GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   0, (4 * GP142_YMAX)/5 ,
		   FILL);

  GP142_triangleXY(FOREST_GREEN,
		   -( 5 * GP142_XMAX/4), TOP_OF_DIRT,
		   (GP142_XMAX)/3  , TOP_OF_DIRT,
		   -(3* GP142_XMAX)/4, (2 * GP142_YMAX)/3 ,
		   FILL);

  GP142_triangleXY(DUSTY_PLUM,
		   -GP142_XMAX / 3 , TOP_OF_DIRT,
		   GP142_XMAX, TOP_OF_DIRT,
		   GP142_XMAX, (2 * GP142_YMAX)/3 ,
		   FILL);

  /* Draw the clouds */
  DrawClouds(175, 200);
  DrawClouds(-135, 175);
  DrawClouds(0, 205);

  /* Draw the dirt */
  /* The dirt is a % of the height of the screen */
  GP142_rectangleXY(BROWN, -GP142_XMAX, -GP142_YMAX,
		    GP142_XMAX, TOP_OF_DIRT, FILL);
  GP142_printfXY (BLACK, text_offset, -GP142_YMAX+30, font_size,
	  "Click a weather type and a color, then click on the picture.");

  /* Draw the twinkling stars */
  for(i=0; i < rand()%10; i++){
  GP142_pixelXY(WHITE, -50, 200);
  GP142_pixelXY(WHITE, 230, 190);
  GP142_pixelXY(WHITE, -125, 220);
  GP142_pixelXY(WHITE, 90, 140);
  GP142_pixelXY(WHITE, -160, 175);
  GP142_pixelXY(WHITE, 130, 180);
  GP142_pixelXY(WHITE, -150, 165);
  GP142_pixelXY(WHITE, 200, 200);
  GP142_pixelXY(WHITE, -120, 130);
  GP142_pixelXY(WHITE, 250, 230);
  GP142_pixelXY(WHITE, 60, 225);
  GP142_pixelXY(WHITE, 0, 230);
  }

  for(j=0; j < rand()%10; j++){
  GP142_pixelXY(WHITE, 100, 200);
  GP142_pixelXY(WHITE, -100, 225);
  GP142_pixelXY(WHITE, 125, 230);
  GP142_pixelXY(WHITE, 140, 240);
  GP142_pixelXY(WHITE, -130, 190);
  GP142_pixelXY(WHITE, -90, 180);
  GP142_pixelXY(WHITE, 170, 210);
  GP142_pixelXY(WHITE, 240, 175);
  GP142_pixelXY(WHITE, -115, 135);
  GP142_pixelXY(WHITE, 180, 130);
  GP142_pixelXY(WHITE, -170, 235);
  }

  /* Draw the Christmas Tree*/
  DrawChristmasTree();
 
}

/* Draw some clouds in the sky                                      */
void DrawClouds (cloud_x, cloud_y)
{
  GP142_circleXY(MED_GRAY, cloud_x, cloud_y, 13);
  GP142_circleXY(MED_GRAY, cloud_x +10, cloud_y -10, 13);
  GP142_circleXY(MED_GRAY, cloud_x +20, cloud_y, 13);
  GP142_circleXY(MED_GRAY, cloud_x +30, cloud_y -10, 13);
}
	
/* Draw the Christmas Tree which is also a part of the background   */
void DrawChristmasTree()
{ 
	int i;

	/*Initialization of various variables required to draw the tree */
	int tree_x1 = 73; 
	int tree_x2 = 197;
	int tree_y = -178;
	int lamp_x1 = 102;
	int lamp_y1 = -60;
	int lamp_x2 = 94;
	int lamp_y2 = -96;
	int lamp_x3 = 86;
	int lamp_y3 = -136;
	int lamp_x4 = 78;
	int lamp_y4 = -175;

	/* Draw the tree */
	GP142_rectangleXY(OLIVE,  110, -200, 160, -178, FILL);

	for(i= 0; i < 4; i++){
    GP142_triangleXY(FOREST_GREEN, tree_x1, tree_y, tree_x2, 
		             tree_y, 135, 5, FILL);
	tree_x1 = tree_x1 + 8;
	tree_x2 = tree_x2 - 8;
	tree_y = tree_y + 40;
	}
    
	/* Draw the lamps around the Christmas Tree */
	GP142_lineXY(WHITE, 100, -61, 156, -33, 4);
	for(i= 0; i < 6; i++){
		GP142_circleXY(rand()%24, lamp_x1, lamp_y1, 2);
		lamp_x1 =lamp_x1 + 10;
		lamp_y1 =lamp_y1 + 5;
	}
	GP142_lineXY(WHITE, 92, -97, 161, -63, 4);
	for(i= 0; i < 7; i++){
		GP142_circleXY(rand()%24, lamp_x2, lamp_y2, 2);
		lamp_x2 = lamp_x2 + 10;
		lamp_y2 = lamp_y2 + 5;
	}
	GP142_lineXY(WHITE, 84, -137, 174, -92, 4);
	for(i= 0; i < 9; i++){
		GP142_circleXY(rand()%24, lamp_x3, lamp_y3, 2);
		lamp_x3 = lamp_x3 + 10;
		lamp_y3 = lamp_y3 + 5;
	}
	GP142_lineXY(WHITE, 76, -177, 182, - 123, 4);
	for(i= 0; i < 11; i++){
		GP142_circleXY(rand()%24, lamp_x4, lamp_y4, 2);
		lamp_x4 = lamp_x4 + 10;
		lamp_y4 = lamp_y4 + 5;
	}

    /* Draw Christmas tree ornaments          */

	/* Draw Diamond ornaments                 */
	DrawDiamonds(YELLOW, 100, -150);
	DrawDiamonds(PINK, 135, -95);
	DrawDiamonds(ICE_BLUE, 170, -158);
	
	/* Draw Hearts ornaments                  */
	DrawHearts(BROWN, 115, -70);
	DrawHearts(RED, 160, -120);
	DrawHearts(MED_GRAY, 120, -170);

	/* Draw Spades ornaments                  */
	DrawSpades(BLACK, 129, -20);
	DrawSpades(CYAN, 132, -131);
	DrawSpades(BLUE, 165, -80);

	/* Draw Club ornaments                    */
	DrawClubs(WHITE, 100, -111);
	DrawClubs(PURPLE, 145, -58);
	DrawClubs(ORANGE, 150, -163);

	/*end DrawChristmasTree */
} 

/* This function draws diamonds on Christmas Tree */
void DrawDiamonds (color, diamond_x, diamond_y)
{
	GP142_triangleXY(color, diamond_x -4,diamond_y,diamond_x +4,diamond_y,
		             diamond_x,diamond_y +4, FILL);
	GP142_triangleXY(color, diamond_x -4,diamond_y,diamond_x +4,diamond_y,
		             diamond_x,diamond_y -4, FILL);
}

/* This function draws hearts on Christmas Tree */
void DrawHearts (color, heart_x, heart_y) {
	GP142_circleXY(color, heart_x - 3, heart_y + 3, 3);
	GP142_circleXY(color, heart_x + 3, heart_y + 3, 3);
	GP142_triangleXY(color, heart_x - 4, heart_y, 
		             heart_x + 4, heart_y, heart_x, heart_y - 4, FILL);
	GP142_pixelXY(color, heart_x, heart_y + 1);
}

/* This function draws spades on Christmas Tree */
void DrawSpades (color, spade_x, spade_y) {
	GP142_circleXY(color, spade_x - 3, spade_y - 3, 3);
	GP142_circleXY(color, spade_x + 3, spade_y - 3, 3);
	GP142_lineXY(color, spade_x, spade_y, spade_x, spade_y -9,1);
	GP142_triangleXY(color, spade_x - 4, spade_y,
		             spade_x + 4, spade_y, spade_x, spade_y + 4, FILL);
}

/* This function draws clubs on Christmas Tree  */
void DrawClubs( color, club_x, club_y) {
	GP142_circleXY(color, club_x - 3, club_y, 3);
	GP142_circleXY(color, club_x + 3, club_y, 3);
	GP142_circleXY(color, club_x, club_y + 5, 3);
	GP142_lineXY(color, club_x, club_y +3, club_x, club_y -6, 1);
}

/*Draw Stanley */
void DrawStanley ()	
{
	int i;
	/* Draw Stanley's arms              */
	GP142_lineXY(PURPLE, -176, -164, -166, -164,9);
	GP142_lineXY(PURPLE, -132, -164, -122, -164,9);
    GP142_circleXY(RED, -179, -164, 4);
	GP142_circleXY(RED, -121, -164, 4);

	/* Draw Stanley's body              */
	GP142_rectangleXY(PURPLE, -174, -185, -125, -165, FILL);
    GP142_triangleXY(BROWN,-174, -185, -174, -167, -170, -167, FILL);
	GP142_triangleXY(BROWN,-125, -185, -125, -167, -129, -167, FILL);
	GP142_lineXY(BLACK, -150, -185, -150, -168, 2);
	GP142_circleXY(BLACK, -153, -170, 1);
	GP142_circleXY(BLACK, -153, -175, 1);
	GP142_circleXY(BLACK, -153, -180, 1);

	/* Draw Stanley's legs              */
	GP142_rectangleXY(NAVY_BLUE, -171, -191, -128, -186, FILL);
	GP142_lineXY(BLACK, -150, -191, -150 , -188, 1);
	
	/* Draw Stanley's head    */
	GP142_circleXY(BLACK,-150,-123, 3);
	GP142_ovalXY(BLUE, -169, -166, -131, -124, FILL);
	GP142_ovalXY(ORANGE, -169, -166, -131, -132, FILL);
	GP142_ovalXY(CHALK, -169, -166, -131, -138, FILL);
    
	/* Draw Stanley's face    */
	
   GP142_ovalXY(CHALK, -151, -153, -143, -143, FILL);
   GP142_lineXY(BLACK, -150, -148, -144, -148, 1);
   GP142_ovalXY(CHALK, -157, -153, -149, -143, FILL);
   GP142_lineXY(BLACK, -156, -148, -150, -148, FILL);      
   
   /* This causes Stanley to blink once in a while */
   for(i=0; i < rand()%15; i++){ 
    GP142_ovalXY(BLACK, -151, -153, -143, -143, 1);
    GP142_ovalXY(BLACK, -157, -153, -149, -143, 1);
	GP142_circleXY(WHITE, -147, -148, 3);
	GP142_circleXY(WHITE, -153, -148, 3);
	GP142_circleXY(BLACK, -147, -148, 1);
    GP142_circleXY(BLACK, -153, -148, 1);
	}
	    
	/* Draw Stanley's mouth             */
    GP142_circleXY(0, -150, -158, 3);
	GP142_circleXY(16, -150, -157,2);	
} 

void DrawKenny (Kenny_X, Kenny_Y, color_1, color_2,
			    color_3, color_4, color_5, color_6,
			    color_7){
/* Draw the Kenny's Head              */
	GP142_ovalXY(color_2, Kenny_X-92, Kenny_Y-166,
		         Kenny_X-54,Kenny_Y -127, FILL);
	GP142_circleXY(color_4, Kenny_X-74,Kenny_Y -147, 12);
	GP142_circleXY(color_4, Kenny_X-74,Kenny_Y -147, 11);
	GP142_ovalXY(color_7, Kenny_X-81, Kenny_Y-158,
		         Kenny_X-67,Kenny_Y -136, FILL);
    GP142_ovalXY(color_6, Kenny_X-81, Kenny_Y-158,
		         Kenny_X-67,Kenny_Y -136, 1);

	/* Draw Kenny's face */
	GP142_ovalXY(color_5, Kenny_X-80, Kenny_Y-151, Kenny_X-74,
		         Kenny_Y-143, 1);
	GP142_ovalXY(color_5, Kenny_X-73, Kenny_Y-151, Kenny_X-67, 
		         Kenny_Y-143, 1);
	GP142_circleXY(color_6, Kenny_X-77, Kenny_Y-147, 3);
	GP142_circleXY(color_6, Kenny_X-70, Kenny_Y-147, 3);
	GP142_circleXY(color_5, Kenny_X-77, Kenny_Y-147, 1);
	GP142_circleXY(color_5, Kenny_X-70, Kenny_Y-147, 1);

	/* Draw Kenny's body */
	GP142_rectangleXY(color_2, Kenny_X-96, Kenny_Y-185, 
		              Kenny_X-49, Kenny_Y-160, FILL);
    GP142_triangleXY(color_1, Kenny_X-96, Kenny_Y-176, 
		             Kenny_X-96, Kenny_Y-160,
		             Kenny_X-92, Kenny_Y-160, FILL);
	GP142_triangleXY(color_1, Kenny_X-49, Kenny_Y-176, 
		             Kenny_X-49, Kenny_Y-160, 
		             Kenny_X-53, Kenny_Y-160, FILL);
    GP142_circleXY(color_1, Kenny_X-90, Kenny_Y-177, 5);
	GP142_lineXY(color_1, Kenny_X-85, Kenny_Y-177, Kenny_X-83, 
		         Kenny_Y-170, 1);
	GP142_circleXY(color_1, Kenny_X-55, Kenny_Y-177, 5);
	GP142_lineXY(color_1, Kenny_X-60, Kenny_Y-177, 
		         Kenny_X-62, Kenny_Y-170, 1);
    GP142_lineXY(color_1, Kenny_X-73, Kenny_Y-186, Kenny_X-73, 
		         Kenny_Y-162, 2);
    GP142_circleXY(color_1, Kenny_X-76, Kenny_Y-170, 1);
	GP142_circleXY(color_1, Kenny_X-76, Kenny_Y-175, 1);
	GP142_circleXY(color_1, Kenny_X-76, Kenny_Y-180, 1);

	/* Draw Kenny's leg  */
	GP142_rectangleXY(color_2, Kenny_X-93, Kenny_Y-191, Kenny_X-52,
		              Kenny_Y-186, FILL);
    GP142_lineXY(color_1, Kenny_X-73, Kenny_Y-191, Kenny_X-73,
		         Kenny_Y-190, 2);

    /* Draw Death Sign   */
    GP142_ovalXY(color_3, Kenny_X-92, Kenny_Y-120, 
		         Kenny_X-54, Kenny_Y-100, FILL);
	GP142_ovalXY(color_4, Kenny_X-89, Kenny_Y-117, 
		         Kenny_X-57, Kenny_Y-103, FILL);
}
	
void DrawStone(int stone_x, int stone_y, int stone_status)
{   
	if (stone_status == TRUE){
   GP142_rectangleXY(MED_GRAY, stone_x, stone_y, stone_x + 55,
	                 stone_y + 70,FILL);
	}
}

/* Figure out which button was clicked */
void handle_button(int x, int y, int *current_precip, 
				   int *current_color, int *clear_weather,
				   int *killing)
{
  int max_speed = 80;
  int buttonNum = 0;

  *clear_weather = FALSE; /* Assume we don't replant */

  /* If we're outside of this area, we could not have clicked on
   * a button.
   */
  if (x > -GP142_XMAX + BUTTON_WIDTH)  return;

  /* The mouse  must be clicking in the column of buttons. */
  buttonNum = (GP142_YMAX - y)/BUTTON_HEIGHT;	 

  /* This is the options available to be selected          */
  switch(buttonNum) {
  case 0:
    *current_precip = RAIN;
    break;

  case 1:
    *current_precip = SNOW;
    break;

  case 2:
	*current_precip = HAIL;
	break;

  case 3:
	*current_precip = HEART;
	break;

  case 4:
    *current_color = WHITE;
    break;

  case 5:
	*current_color = BLUE;
	break;

  case 6:
    *current_color = YELLOW;
    break;

  case 7:
	*current_color = RED;
	break;

  case 8:
	*killing = TRUE;
	break;

  case 9:
    *clear_weather = LIGHTEN_UP;
    break; 

  case 10:
	*clear_weather = CEASE;
	break;
 
  default:
  /*Bad news if this is ever reached! */
		BadNewsMessage();
    break;
  }

}

/* Draws the buttons */
void DrawButtons(int current_precip, int current_color)
{
  int i, text_offset = -GP142_XMAX + 15, font_size = 12;

  /* draw rectangles for each button */
  for(i = 0; i < NUM_BUTTONS; i++) {
    GP142_rectangleXY(UNSELECTED_COLOR,
		      -GP142_XMAX + 4,
		      GP142_YMAX - i * BUTTON_HEIGHT - 2,
		      -GP142_XMAX + BUTTON_WIDTH,
		      GP142_YMAX - (i + 1)*BUTTON_HEIGHT - 2, 1);
  }

  /* display button text */
  /* "selected" buttons are highlighted */
  
  i = GP142_YMAX - 25;
  if (current_precip == RAIN)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size+5, "Rain");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Rain");	

  i -= BUTTON_HEIGHT;
  if (current_precip == SNOW)
    GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size+5, "Snow");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Snow");

  i -= BUTTON_HEIGHT;
  if (current_precip == HAIL)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size+5, "Hail");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Hail");

  i -= BUTTON_HEIGHT;
  if (current_precip == HEART)
	  GP142_printfXY(SELECTED_COLOR, text_offset, i, font_size+5, "Heart");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Heart");
 
  /* Buttons for Colors */
  i -= BUTTON_HEIGHT;
  if (current_color == WHITE)
    GP142_printfXY(WHITE, text_offset, i, font_size + 5, "White");	
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "White");

  i -= BUTTON_HEIGHT;
  if (current_color == BLUE)
    GP142_printfXY(BLUE, text_offset, i, font_size + 5, "Blue");
  else
    GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Blue");

  i -= BUTTON_HEIGHT;
  if (current_color == YELLOW)
	GP142_printfXY(YELLOW, text_offset, i, font_size + 5, "Yellow");
  else
	GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Yellow");

  i -= BUTTON_HEIGHT;
  if (current_color == RED)
	  GP142_printfXY(RED, text_offset, i, font_size + 5, "Red");
  else
	  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Red");

  /* This button is selected when user wants to kill Kenny          */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, 
	             font_size, "Oh My God !!!");

  /* These buttons are selected when user decides to clear some or
     all precipitations                                             */
  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size,
	             "Lighten Up");

  i -= BUTTON_HEIGHT;
  GP142_printfXY(UNSELECTED_COLOR, text_offset, i, font_size, "Cease!");

}

void opening(void)
{   
	int mouse_x;
	int mouse_y;
	char key_hit;
	
	GP142_rectangleXY(BLACK, -GP142_XMAX, -GP142_YMAX, GP142_XMAX, 
		              GP142_YMAX, FILL);
    GP142_printfXY(BLUE, -GP142_XMAX + 170, GP142_YMAX - 100, 
		           25, "CHARLIE CHANDRA");
	GP142_printfXY(GREEN, -GP142_XMAX + 250, GP142_YMAX -130,
		           20, "presents");
	GP142_printfXY(RED, -GP142_XMAX + 120, GP142_YMAX -200,
		           45, "Kenny's Nightmare");
	GP142_printfXY(RED, -GP142_XMAX + 137, GP142_YMAX -250,
		           45, "Before Christmas");
	GP142_printfXY(GOLD, -GP142_XMAX + 250, GP142_YMAX -270,
		           18, "starring");
    /*Draw Kenny Ghost                                              */
    DrawKenny(50, 75, BLACK, WHITE, YELLOW, BLACK, BLACK,
		      WHITE, WHITE);
    GP142_printfXY(WHITE, -GP142_XMAX +210, -GP142_YMAX + 100,
		           10,"Click anywhere on the screen");
	GP142_printfXY(WHITE, -GP142_XMAX +220, -GP142_YMAX + 85,
		           10, "or press any key to begin");
       
	GP142_await_event(&mouse_x, &mouse_y, &key_hit);
}

/* This function is never called                                    */
void BadNewsMessage (void) {
	GP142_printfXY (RED, 0, 0, 16, "BAAAADDD NEWS!");
}
